////////////////////////////////////////////////////////////////
// Object3D_GL.cpp
// OpenGL 3DObject implmentation
//
////////////////////////////////////////////////////////////////

#include "GL\Object3D_GL.h"

void Object3D::Draw(Screen_GL* pScreen)
{
	Frm::Subset* TempSubset;
   Frm::Face TempFace;
   std::list<Frm::Subset*>::iterator i = _Mesh->_Subsets.begin();
   std::list<Frm::Material*>::iterator j = _Mesh->_Materials.begin();

   while (j != _Mesh->_Materials.end())
   	{
      pScreen->SetMaterial(*j);
      TempSubset = *i;
	   glBegin(GL_TRIANGLES);
   	  	for(int k = 0; k < TempSubset->Size; k++)
      	  	{
            TempFace = TempSubset->Faces[k];
         	glTexCoord2fv(_Mesh->_TextureCoords[TempFace.data[0]].data);
         	glVertex3fv(_SkinnedVertices[TempFace.data[0]].data);
         	glTexCoord2fv(_Mesh->_TextureCoords[TempFace.data[1]].data);
         	glVertex3fv(_SkinnedVertices[TempFace.data[1]].data);
         	glTexCoord2fv(_Mesh->_TextureCoords[TempFace.data[2]].data);
         	glVertex3fv(_SkinnedVertices[TempFace.data[2]].data);
         	}
   	glEnd();
      i++;
      j++;
      }
}

void Object3D::ComputeBoundingBoxSphere(void)
{
	_Low = _SkinnedVertices[0];
   _High = _Low;
   _Center = _Low;
   _Radius = 0.0f;
	for(int i = 0; i < _Mesh->_nVertices; i++)
   	{
      if (_Low[0]> _SkinnedVertices[i][0])
      	_Low[0] = _SkinnedVertices[i][0];
      if (_Low[1]> _SkinnedVertices[i][1])
      	_Low[1] = _SkinnedVertices[i][1];
      if (_Low[2]> _SkinnedVertices[i][2])
      	_Low[2] = _SkinnedVertices[i][2];
      if (_High[0]< _SkinnedVertices[i][0])
      	_High[0] = _SkinnedVertices[i][0];
      if (_High[1]< _SkinnedVertices[i][1])
      	_High[1] = _SkinnedVertices[i][1];
      if (_High[2]< _SkinnedVertices[i][2])
      	_High[2] = _SkinnedVertices[i][2];
      }
   	_Center[0] = _Low[0] + (_High[0] - _Low[0])*0.5f;
      _Center[1] = _Low[1] + (_High[1] - _Low[1])*0.5f;
      _Center[2] = _Low[2] + (_High[2] - _Low[2])*0.5f;

      MYTRACE("AABB Low:", _Low[0], "x", _Low[1], "x", _Low[2]);
      MYTRACE("AABB High:", _High[0], "x", _High[1], "x", _High[2]);
      MYTRACE("AABB Center:", _Center[0], "x", _Center[1], "x", _Center[2]);
}
