////////////////////////////////////////////////////////////////
// 3DObject_GL.h
// OpenGL Screen implmentation
//
////////////////////////////////////////////////////////////////

#ifndef _OBJECT3D_GL
#define _OBJECT3D_GL

#define DEBUG

#include "framework\Frm_Mesh.h" //based on the correct Mesh element
#include "GL\Screen_GL.h"

class Object3D
{
   public:
		Object3D(void): _SkinnedVertices(0), _Model(0){};
      ~Object3D(void){if (_SkinnedVertices!=0) delete[] _SkinnedVertices;}
      void SetupModel(Frm::Model3D* pModel){
      	_Model = pModel;
         _Mesh = _Model->_Meshes.front();
         _SkinnedVertices = new Frm::Vertex[_Mesh->_nVertices];
         ComputeBoundingBoxSphere();
         };

      //Vertices to render
      void ClearSkinnedVertices(void){memset(_SkinnedVertices, 0, _Mesh->_nVertices * sizeof(Frm::Vertex));};

      //Animation Based
      inline void Update(void){memcpy(_SkinnedVertices, _Mesh->_Vertices, _Mesh->_nVertices * sizeof(Frm::Vertex));};
      void Draw(Screen_GL* pScreen);

      void ComputeBoundingBoxSphere(void);
      //Elements for the AABB (_Low & _High)
      //and bounding sphere (_Center & _Radius)
      Frm::Vertex _Low, _High, _Center;
      float _Radius;

   private:
      Frm::Mesh* _Mesh; //pointer to Model Mesh
      Frm::Vertex* _SkinnedVertices;
		Frm::Model3D* _Model;
};

#endif
